# Changelog

## v3.22.5

### Improvements

* DL-85 - Add SESSION_ID custom dimension to page views and event actions

## v3.22.4

### Bugfixes

* DL-82 - Fix splashscreen flicker from cold open

## v3.22.3

### Bugfixes

* CONN-379 - DL rejects pageviews with Google prop

## v3.22.2

### Bugfixes

* DL-79 - DL retries regardless of configuration

### Improvements

* #238 - Updated PR template to add README update

## v3.22.1

### Bugfixes

* DL-77 - Fix issue where app would crash with an invalid GA ID

## v3.22.0

### Features

* DL-56 - Pull web app styles through to mobile app
* DL-73 - Event tracking

### Bugfixes

* DL-72 - Autoupdate only works once

## v3.21.0

### Features

* DL-73 - Event tracking (initial interface)

### Bugfixes

* DL-75 - Data layer does not refresh notifications when the user logs in

## v3.20.0

### Features

* DL-47 - Configurable global retry
* DL-52 - Optional no retry requests
* DL-69 - Rerequest schema on login
* DL-70 - `site.login()` to resolve after all related requests

### Improvements

* DL-46 - Implement logging/debug updates
* DL-48 - Remove the "preflight" stage
* DL-49 - Remove the "change status" action type
* DL-50 - Use standard pipeline dispatch technique in the store refresh loop
* DL-51 - Perform delay update as a single action

## v3.19.0

### Features

* DL-61 - Allow configurable request retry interval

### Bugfixes

* CONN-294 - iOS media only uploads the first file

## v3.18.4

### Bugfixes

* LEARN-206 - Offline activities don't sync when back online

## v3.18.3

### Bugfixes

* CONN-269 - Amplify Dev app crashing

### Improvements

* DL-59 - Upgrade to latest version of ESLint configuration

## v3.18.2

### Bugfixes

* DL-58 - Response should cope if collections do not have IDs

### Improvements

* DL-44 - Upgrade DL dependencies
* DL-33 - Use standard ESLint configuration for DataLayer

## v3.18.1

### Bugfixes

* CONN-201 - Remove `window.location.reload` from `reboot.js`

## v3.18.0

### Features

* LEARN-43 - Added `site.getConnectionType()` and associated constants

## v3.17.0

### Features

* REACT-20 - `Site.getRequestByRoute()` to support `<Collection>` component

## v3.16.4

### Bugfixes

* DL-32 - `getObjectBySlug()` returns `undefined`

## v3.16.3

### Bugfixes

* DL-28 - Requests fail on IE11 when Symbol polyfill available

## v3.16.2

### Bugfixes

* #183 - Error thrown when registering for push notifications

## v3.16.1

### Bugfixes

* #178 - If `total` and `totalPages` are strings it returns `undefined`
* #179 - `Site.getCollectionByRoute()` not working

## v3.16.0

### Features

* #148 - Return `undefined` for an unauthorized collection response
* #176 - Do not reject on notification registration error

### Bugfixes

* #172 - `Response.total` and `Response.totalPages` `undefined` not `0`

### Improvements

* #156 - Split out platform-specific code

## v3.15.0

### Features

* #170 - Added status properties to responses

### Bugfixes

* #169 - Corrected invocations of `Error` constructor

### Improvements

* #142 - Remove unused config folder
* #145 - Add tests for events

## v3.14.0

History begins...
