import { contains } from 'ramda';

import { PLATFORM_CORDOVA, PLATFORM_NODEJS } from '../const';
import { platform } from '../utils';

/**
 * Checks whether the platform permits downloads
 * @returns {boolean}
 */
export const supportsDownload = () =>
  contains(platform(), [PLATFORM_CORDOVA, PLATFORM_NODEJS]);
